Index: vi/v_word.c
Prereq: 	10.5 
*** nvi-1.79/vi/v_word.c	Sun Apr 28 00:21:27 1996
--- nvi-1.79-m17n/vi/v_word.c	Fri Feb 21 22:20:45 1997
***************
*** 111,116 ****
--- 111,119 ----
  	enum { INWORD, NOTWORD } state;
  	VCS cs;
  	u_long cnt;
+ #ifdef MULTIBYTE
+ 	u_int ochclass, chclass;
+ #endif
  
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	cs.cs_lno = vp->m_start.lno;
***************
*** 148,161 ****
--- 151,200 ----
  	 */
  	if (type == BIGWORD)
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto Singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
+ 			for (;;) {
+ 				if (cs_multi_next(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_EOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto Taileater;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_Wordbound(ochclass, chclass, 1))
+ 					goto Taileater;
+ 				ochclass = chclass;
+ 			}
+ Singlebyte:;
+ #endif /*MULTIBYTE*/
  			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_EOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  			}
+ #ifdef MULTIBYTE
+ Taileater:;
+ #endif
  			/*
  			 * If a motion command and we're at the end of the
  			 * last word, we're done.  Delete and yank eat any
***************
*** 171,192 ****
--- 210,271 ----
  			}
  
  			/* Eat whitespace characters. */
+ #ifndef MULTIBYTE
  			if (cs_fblank(sp, &cs))
  				return (1);
+ #else
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ 			if (isblank(cs.cs_ch) && cs_fblank(sp, &cs))
+ 				return (1);
+ #endif /*MULTIBYTE*/
  			if (cs.cs_flags == CS_EOF)
  				goto ret;
  		}
  	else
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
+ 			for (;;) {
+ 				if (cs_multi_next(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_EOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto taileater;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_wordbound(ochclass, chclass, 1))
+ 					goto taileater;
+ 				ochclass = chclass;
+ 			}
+ singlebyte:;
+ #endif /*MULTIBYTE*/
  			state = cs.cs_flags == 0 &&
  			    inword(cs.cs_ch) ? INWORD : NOTWORD;
  			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_EOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  				if (state == INWORD) {
  					if (!inword(cs.cs_ch))
  						break;
***************
*** 194,199 ****
--- 273,281 ----
  					if (inword(cs.cs_ch))
  						break;
  			}
+ #ifdef MULTIBYTE
+ taileater:;
+ #endif
  			/* See comment above. */
  			if (cnt == 0 && ISMOTION(vp)) {
  				if ((ISCMD(vp->rkp, 'd') ||
***************
*** 204,209 ****
--- 286,295 ----
  			}
  
  			/* Eat whitespace characters. */
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ #endif /*MULTIBYTE*/
  			if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  				if (cs_fblank(sp, &cs))
  					return (1);
***************
*** 227,233 ****
--- 313,329 ----
  	vp->m_stop.lno = cs.cs_lno;
  	vp->m_stop.cno = cs.cs_cno;
  	if (ISMOTION(vp) && cs.cs_flags == 0)
+ #ifndef MULTIBYTE
  		--vp->m_stop.cno;
+ #else
+ 	{
+ 		char *p;
+ 		if (db_eget(sp, vp->m_stop.lno, &p, NULL, NULL))
+ 			return 1;
+ 		vp->m_stop.cno -= multi_back(sp, (CHAR_T *)p,
+ 					(CHAR_T *)&p[vp->m_stop.cno]);
+ 	}
+ #endif /*MULTIBYTE*/
  
  	/*
  	 * Non-motion commands move to the end of the range.  Delete
***************
*** 278,283 ****
--- 374,382 ----
  	enum { INWORD, NOTWORD } state;
  	VCS cs;
  	u_long cnt;
+ #ifdef MULTIBYTE
+ 	u_int ochclass, chclass;
+ #endif
  
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	cs.cs_lno = vp->m_start.lno;
***************
*** 292,298 ****
--- 391,401 ----
  	 * past the current one, it sets word "state" for the 'e' command.
  	 */
  	if (cs.cs_flags == 0 && !isblank(cs.cs_ch)) {
+ #ifndef MULTIBYTE
  		if (cs_next(sp, &cs))
+ #else
+ 		if (cs_multi_next(sp, &cs))
+ #endif
  			return (1);
  		if (cs.cs_flags == 0 && !isblank(cs.cs_ch))
  			goto start;
***************
*** 308,349 ****
--- 411,532 ----
  	 */
  start:	if (type == BIGWORD)
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto Singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
  			for (;;) {
+ 				if (cs_multi_next(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_EOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto Taileater;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_Wordbound(ochclass, chclass, 1))
+ 					goto Taileater;
+ 				ochclass = chclass;
+ 			}
+ Singlebyte:;
+ #endif /*MULTIBYTE*/
+ 			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_EOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  			}
+ #ifdef MULTIBYTE
+ Taileater:;
+ #endif
  			/*
  			 * When we reach the start of the word after the last
  			 * word, we're done.  If we changed state, back up one
  			 * to the end of the previous word.
  			 */
  			if (cnt == 0) {
+ #ifndef MULTIBYTE
  				if (cs.cs_flags == 0 && cs_prev(sp, &cs))
+ #else
+ 				if (cs.cs_flags == 0 && cs_multi_prev(sp, &cs))
+ #endif
  					return (1);
  				break;
  			}
  
  			/* Eat whitespace characters. */
+ #ifndef MULTIBYTE
  			if (cs_fblank(sp, &cs))
  				return (1);
+ #else
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ 			if (isblank(cs.cs_ch) && cs_fblank(sp, &cs))
+ 				return (1);
+ #endif /*MULTIBYTE*/
  			if (cs.cs_flags == CS_EOF)
  				goto ret;
  		}
  	else
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
+ 			for (;;) {
+ 				if (cs_multi_next(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_EOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto taileater;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_wordbound(ochclass, chclass, 1))
+ 					goto taileater;
+ 				ochclass = chclass;
+ 			}
+ singlebyte:;
+ #endif /*MULTIBYTE*/
  			state = cs.cs_flags == 0 &&
  			    inword(cs.cs_ch) ? INWORD : NOTWORD;
  			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_next(sp, &cs))
+ #else
+ 				if (cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_EOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  				if (state == INWORD) {
  					if (!inword(cs.cs_ch))
  						break;
***************
*** 351,364 ****
--- 534,558 ----
  					if (inword(cs.cs_ch))
  						break;
  			}
+ #ifdef MULTIBYTE
+ taileater:;
+ #endif
  			/* See comment above. */
  			if (cnt == 0) {
+ #ifndef MULTIBYTE
  				if (cs.cs_flags == 0 && cs_prev(sp, &cs))
+ #else
+ 				if (cs.cs_flags == 0 && cs_multi_prev(sp, &cs))
+ #endif
  					return (1);
  				break;
  			}
  
  			/* Eat whitespace characters. */
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ #endif /*MULTIBYTE*/
  			if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  				if (cs_fblank(sp, &cs))
  					return (1);
***************
*** 431,436 ****
--- 625,633 ----
  	enum { INWORD, NOTWORD } state;
  	VCS cs;
  	u_long cnt;
+ #ifdef MULTIBYTE
+ 	u_int ochclass, chclass;
+ #endif
  
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	cs.cs_lno = vp->m_start.lno;
***************
*** 446,452 ****
--- 643,653 ----
  	 * 'b' command.
  	 */
  	if (cs.cs_flags == 0 && !isblank(cs.cs_ch)) {
+ #ifndef MULTIBYTE
  		if (cs_prev(sp, &cs))
+ #else
+ 		if (cs_multi_prev(sp, &cs))
+ #endif
  			return (1);
  		if (cs.cs_flags == 0 && !isblank(cs.cs_ch))
  			goto start;
***************
*** 462,487 ****
--- 663,734 ----
  	 */
  start:	if (type == BIGWORD)
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto Singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
  			for (;;) {
+ 				if (cs_multi_prev(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_SOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto Cntmodify;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_Wordbound(ochclass, chclass, 0))
+ 					goto Cntmodify;
+ 				ochclass = chclass;
+ 			}
+ Singlebyte:;
+ #endif /*MULTIBYTE*/
+ 			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_prev(sp, &cs))
+ #else
+ 				if (cs_multi_prev(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_SOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  			}
+ #ifdef MULTIBYTE
+ Cntmodify:;
+ #endif
  			/*
  			 * When we reach the end of the word before the last
  			 * word, we're done.  If we changed state, move forward
  			 * one to the end of the next word.
  			 */
  			if (cnt == 0) {
+ #ifndef MULTIBYTE
  				if (cs.cs_flags == 0 && cs_next(sp, &cs))
+ #else
+ 				if (cs.cs_flags == 0 && cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				break;
  			}
  
  			/* Eat whitespace characters. */
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ 			if (!isblank(cs.cs_ch))
+ 				continue;
+ #endif /*MULTIBYTE*/
  			if (cs_bblank(sp, &cs))
  				return (1);
  			if (cs.cs_flags == CS_SOF)
***************
*** 489,503 ****
--- 736,783 ----
  		}
  	else
  		while (cnt--) {
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags != 0 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 				goto singlebyte;
+ 			
+ 			/*
+ 			 * Multibyte case.
+ 			 * It is not very good to peep VCS structure directly,
+ 			 * but it is the fastest and easiest way.
+ 			 */
+ 			ochclass = multi_chclass(&cs.cs_bp[cs.cs_cno], 0);
+ 			for (;;) {
+ 				if (cs_multi_prev(sp, &cs))
+ 					return 1;
+ 				if (cs.cs_flags == CS_SOF)
+ 					goto ret;
+ 				if (cs.cs_flags != 0
+ 				 || KEY_BLEN(sp, cs.cs_ch) == 1)
+ 					goto cntmodify;
+ 				chclass = multi_chclass(&cs.cs_bp[cs.cs_cno], ochclass);
+ 				if (multi_wordbound(ochclass, chclass, 0))
+ 					goto cntmodify;
+ 				ochclass = chclass;
+ 			}
+ singlebyte:;
+ #endif /*MULTIBYTE*/
  			state = cs.cs_flags == 0 &&
  			    inword(cs.cs_ch) ? INWORD : NOTWORD;
  			for (;;) {
+ #ifndef MULTIBYTE
  				if (cs_prev(sp, &cs))
+ #else
+ 				if (cs_multi_prev(sp, &cs))
+ #endif
  					return (1);
  				if (cs.cs_flags == CS_SOF)
  					goto ret;
  				if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  					break;
+ #ifdef MULTIBYTE
+ 				if (1 < KEY_BLEN(sp, cs.cs_ch))
+ 					break;
+ #endif /*MULTIBYTE*/
  				if (state == INWORD) {
  					if (!inword(cs.cs_ch))
  						break;
***************
*** 505,518 ****
--- 785,809 ----
  					if (inword(cs.cs_ch))
  						break;
  			}
+ #ifdef MULTIBYTE
+ cntmodify:;
+ #endif
  			/* See comment above. */
  			if (cnt == 0) {
+ #ifndef MULTIBYTE
  				if (cs.cs_flags == 0 && cs_next(sp, &cs))
+ #else
+ 				if (cs.cs_flags == 0 && cs_multi_next(sp, &cs))
+ #endif
  					return (1);
  				break;
  			}
  
  			/* Eat whitespace characters. */
+ #ifdef MULTIBYTE
+ 			if (cs.cs_flags == 0 && 1 < KEY_BLEN(sp, cs.cs_ch))
+ 				continue;
+ #endif /*MULTIBYTE*/
  			if (cs.cs_flags != 0 || isblank(cs.cs_ch))
  				if (cs_bblank(sp, &cs))
  					return (1);
***************
*** 542,547 ****
--- 833,848 ----
  	 */
  	vp->m_final = vp->m_stop;
  	if (ISMOTION(vp))
+ #ifndef MULTIBYTE
  		--vp->m_start.cno;
+ #else
+ 	{
+ 		char *p;
+ 		if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 			return 1;
+ 		vp->m_start.cno -= multi_back(sp, (CHAR_T *)p,
+ 					(CHAR_T *)&p[vp->m_start.cno]);
+ 	}
+ #endif /*MULTIBYTE*/
  	return (0);
  }
Index: vi/v_xchar.c
Prereq: 	10.9 
*** nvi-1.79/vi/v_xchar.c	Wed Oct 23 22:31:52 1996
--- nvi-1.79-m17n/vi/v_xchar.c	Tue Nov 26 00:24:09 1996
***************
*** 37,44 ****
  {
  	size_t len;
  	int isempty;
! 
! 	if (db_eget(sp, vp->m_start.lno, NULL, &len, &isempty)) {
  		if (isempty)
  			goto nodel;
  		return (1);
--- 37,53 ----
  {
  	size_t len;
  	int isempty;
! #ifdef MULTIBYTE
! 	CHAR_T *p;
! 	size_t lastlen;
! #endif
! 
! #ifndef MULTIBYTE
! 	if (db_eget(sp, vp->m_start.lno, NULL, &len, &isempty))
! #else
! 	if (db_eget(sp, vp->m_start.lno, &p, &len, &isempty))
! #endif
! 	{
  		if (isempty)
  			goto nodel;
  		return (1);
***************
*** 57,68 ****
  	 * of the cursor as part of the 'x' command isn't taken into account.
  	 * Historically correct.
  	 */
! 	if (F_ISSET(vp, VC_C1SET))
  		vp->m_stop.cno += vp->count - 1;
  	if (vp->m_stop.cno >= len - 1) {
  		vp->m_stop.cno = len - 1;
  		vp->m_final.cno = vp->m_start.cno ? vp->m_start.cno - 1 : 0;
! 	} else
  		vp->m_final.cno = vp->m_start.cno;
  
  	if (cut(sp,
--- 66,97 ----
  	 * of the cursor as part of the 'x' command isn't taken into account.
  	 * Historically correct.
  	 */
! 	if (F_ISSET(vp, VC_C1SET)) {
! #ifndef MULTIBYTE
  		vp->m_stop.cno += vp->count - 1;
+ #else
+ 		int i;
+ 		for (i = 0; i < vp->count - 1; i++)
+ 			vp->m_stop.cno += KEY_BLEN(sp, p[vp->m_stop.cno]);
+ #endif /*MULTIBYTE*/
+ 	}
+ #ifndef MULTIBYTE
  	if (vp->m_stop.cno >= len - 1) {
  		vp->m_stop.cno = len - 1;
  		vp->m_final.cno = vp->m_start.cno ? vp->m_start.cno - 1 : 0;
! 	}
! #else
! 	lastlen = len - multi_back(sp, p, &p[len]);
! 	if (vp->m_stop.cno >= lastlen) {
! 		vp->m_stop.cno = lastlen;
! 		if (vp->m_start.cno) {
! 			vp->m_final.cno = vp->m_start.cno
! 				- multi_back(sp, p, &p[vp->m_start.cno]);
! 		} else
! 			vp->m_final.cno = 0;
! 	}
! #endif /*MULTIBYTE*/
! 	else
  		vp->m_final.cno = vp->m_start.cno;
  
  	if (cut(sp,
***************
*** 85,102 ****
  	VICMD *vp;
  {
  	u_long cnt;
  
  	if (vp->m_start.cno == 0) {
  		v_sol(sp);
  		return (1);
  	}
  
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	if (cnt >= vp->m_start.cno)
  		vp->m_start.cno = 0;
! 	else
  		vp->m_start.cno -= cnt;
  	--vp->m_stop.cno;
  	vp->m_final.cno = vp->m_start.cno;
  
  	if (cut(sp,
--- 114,151 ----
  	VICMD *vp;
  {
  	u_long cnt;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p;
+ #endif
  
  	if (vp->m_start.cno == 0) {
  		v_sol(sp);
  		return (1);
  	}
  
+ #ifdef MULTIBYTE
+ 	/* we need content of the line. */
+ 	if (db_eget(sp, vp->m_start.lno, &p, NULL, NULL))
+ 		return (1);
+ #endif
+ 
  	cnt = F_ISSET(vp, VC_C1SET) ? vp->count : 1;
  	if (cnt >= vp->m_start.cno)
  		vp->m_start.cno = 0;
! 	else {
! #ifndef MULTIBYTE
  		vp->m_start.cno -= cnt;
+ #else
+ 		int i;
+ 		for (i = 0; i < cnt; i++)
+ 			vp->m_start.cno -= multi_back(sp, p, &p[vp->m_start.cno]);
+ #endif /*MULTIBYTE*/
+ 	}
+ #ifndef MULTIBYTE
  	--vp->m_stop.cno;
+ #else
+ 	vp->m_stop.cno -= multi_back(sp, p, &p[vp->m_stop.cno]);
+ #endif
  	vp->m_final.cno = vp->m_start.cno;
  
  	if (cut(sp,
Index: vi/v_yank.c
Prereq: 	10.9 
*** nvi-1.79/vi/v_yank.c	Mon May 20 01:02:04 1996
--- nvi-1.79-m17n/vi/v_yank.c	Sat Feb 22 00:24:13 1997
***************
*** 75,82 ****
  		F_SET(vp, VM_RCM_SET);
  
  		/* Make sure the set cursor position exists. */
! 		if (vp->m_final.cno >= len)
  			vp->m_final.cno = len ? len - 1 : 0;
  	}
  	return (0);
  }
--- 75,90 ----
  		F_SET(vp, VM_RCM_SET);
  
  		/* Make sure the set cursor position exists. */
! 		if (vp->m_final.cno >= len) {
! #ifndef MULTIBYTE
  			vp->m_final.cno = len ? len - 1 : 0;
+ #else
+ 			CHAR_T *p;
+ 			if (db_get(sp, vp->m_final.lno, DBG_FATAL, &p, NULL))
+ 				return (1);
+ 			vp->m_final.cno = len ? len - multi_back(sp, p, &p[len]) : 0;
+ #endif /*MULTIBYTE*/
+ 		}
  	}
  	return (0);
  }
Index: vi/vi.c
Prereq: 	10.57 
*** nvi-1.79/vi/vi.c	Wed Oct 23 22:31:58 1996
--- nvi-1.79-m17n/vi/vi.c	Fri Mar 28 00:21:56 1997
***************
*** 91,96 ****
--- 91,100 ----
  	(void)sp->gp->scr_rename(sp, sp->frp->name, 1);
  
  	for (vip = VIP(sp), rval = 0;;) {
+ #if 0
+ 		v_fep_force_off(sp);
+ #endif /*CANNA*/
+ 
  		/* Resolve messages. */
  		if (!MAPPED_KEYS_WAITING(sp) && vs_resolve(sp, NULL, 0))
  			goto ret;
***************
*** 232,239 ****
--- 236,258 ----
  		v_comlog(sp, vp);
  #endif
  		/* Call the function. */
+ #ifndef MULTIBYTE
  ex_continue:	if (vp->kp->func(sp, vp))
  			goto err;
+ #else
+ ex_continue:
+ 	    {
+ 		int rval;
+ 
+ 		if (strchr(O_STR(sp, O_FEPKEY), vp->key))
+ 			v_fep_on(sp);
+ 		rval = vp->kp->func(sp, vp);
+ 		if (strchr(O_STR(sp, O_FEPKEY), vp->key))
+ 			v_fep_off(sp);
+ 		if (rval)
+ 			goto err;
+ 	    }
+ #endif /*MULTIBYTE*/
  gc_event:
  #ifdef DEBUG
  		/* Make sure no function left the temporary space locked. */
***************
*** 413,418 ****
--- 432,438 ----
  	return (rval);
  }
  
+ #ifndef MULTIBYTE
  #define	KEY(key, ec_flags) {						\
  	if ((gcret = v_key(sp, 0, &ev, ec_flags)) != GC_OK)		\
  		return (gcret);						\
***************
*** 422,427 ****
--- 442,470 ----
  		*mappedp = 1;						\
  	key = ev.e_c;							\
  }
+ #else
+ #define	KEY0(key, ec_flags) {						\
+ 	if ((gcret = v_key(sp, 0, &ev, ec_flags)) != GC_OK)		\
+ 		return (gcret);						\
+ 	if (ev.e_value == K_ESCAPE)					\
+ 		goto esc;						\
+ 	if (F_ISSET(&ev.e_ch, CH_MAPPED))				\
+ 		*mappedp = 1;						\
+ 	key = ev.e_c;							\
+ }
+ 
+ #define	KEY(key, ec_flags) {						\
+ 	if ((gcret = v_key(sp, 0, &ev, ec_flags)) != GC_OK)		\
+ 		return (gcret);						\
+ 	if (ev.e_value == K_ESCAPE)					\
+ 		goto esc;						\
+ 	if (1 < KEY_BLEN(sp, ev.e_c))					\
+ 		goto mbyte;						\
+ 	if (F_ISSET(&ev.e_ch, CH_MAPPED))				\
+ 		*mappedp = 1;						\
+ 	key = ev.e_c;							\
+ }
+ #endif /*MULTIBYTE*/
  
  /*
   * The O_TILDEOP option makes the ~ command take a motion instead
***************
*** 466,471 ****
--- 509,518 ----
  	CHAR_T key;
  	char *s;
  
+ #ifdef MULTIBYTE
+ 	v_fep_force_off(sp);
+ #endif
+ 
  	/*
  	 * Get a key.
  	 *
***************
*** 487,492 ****
--- 534,543 ----
  	}
  	if (ev.e_value == K_ESCAPE)
  		goto esc;
+ #ifdef MULTIBYTE
+ 	if (1 < KEY_BLEN(sp, ev.e_c))
+ 		goto mbyte;
+ #endif
  	if (F_ISSET(&ev.e_ch, CH_MAPPED))
  		*mappedp = 1;
  	key = ev.e_c;
***************
*** 688,695 ****
  	}
  
  	/* Required character. */
! 	if (LF_ISSET(V_CHAR))
  		KEY(vp->character, 0);
  
  	/* Get any associated cursor word. */
  	if (F_ISSET(kp, V_KEYW) && v_keyword(sp))
--- 739,760 ----
  	}
  
  	/* Required character. */
! 	if (LF_ISSET(V_CHAR)) {
! #ifndef MULTIBYTE
  		KEY(vp->character, 0);
+ #else
+ 		size_t i, blen;
+ 
+ 		if (strchr(O_STR(sp, O_FEPKEY), vp->key))
+ 			v_fep_on(sp);
+ 		KEY0(vp->characters[0], 0);
+ 		blen = KEY_BLEN(sp, vp->characters[0]);
+ 		for (i = 1; i < blen; i++)
+ 			KEY0(vp->characters[i], 0);
+ 		if (strchr(O_STR(sp, O_FEPKEY), vp->key))
+ 			v_fep_off(sp);
+ #endif /*MULTIBYTE*/
+ 	}
  
  	/* Get any associated cursor word. */
  	if (F_ISSET(kp, V_KEYW) && v_keyword(sp))
***************
*** 708,713 ****
--- 773,793 ----
  		break;
  	}
  	return (GC_ERR);
+ 
+ #ifdef MULTIBYTE
+ mbyte:
+     {
+ 	size_t blen;
+ 	size_t i;
+ 	CHAR_T tmp;
+ 
+ 	blen = KEY_BLEN(sp, ev.e_c);
+ 	for (i = 1; i < blen; i++)
+ 		KEY0(tmp, 0);
+ 	msgq(sp, M_BERR, "Illegal multibyte char in command");
+ 	return GC_ERR;
+     }
+ #endif /*MULTIBYTE*/
  }
  
  /*
***************
*** 726,731 ****
--- 806,814 ----
  	u_long cnt;
  	u_int flags;
  	int tilde_reset, notused;
+ #ifdef MULTIBYTE
+ 	CHAR_T *p0;
+ #endif
  
  	/*
  	 * If '.' command, use the dot motion, else get the motion command.
***************
*** 783,789 ****
  		 * text.
  		 */
  		vp->m_stop.lno = sp->lno + motion.count - 1;
! 		if (db_get(sp, vp->m_stop.lno, 0, NULL, &len)) {
  			if (vp->m_stop.lno != 1 ||
  			   vp->key != 'c' && vp->key != '!') {
  				v_emsg(sp, NULL, VIM_EMPTY);
--- 866,877 ----
  		 * text.
  		 */
  		vp->m_stop.lno = sp->lno + motion.count - 1;
! #ifndef MULTIBYTE
! 		if (db_get(sp, vp->m_stop.lno, 0, NULL, &len))
! #else
! 		if (db_get(sp, vp->m_stop.lno, 0, &p0, &len))
! #endif
! 		{
  			if (vp->m_stop.lno != 1 ||
  			   vp->key != 'c' && vp->key != '!') {
  				v_emsg(sp, NULL, VIM_EMPTY);
***************
*** 791,797 ****
--- 879,891 ----
  			}
  			vp->m_stop.cno = 0;
  		} else
+ #ifndef MULTIBYTE
  			vp->m_stop.cno = len ? len - 1 : 0;
+ #else
+ 			vp->m_stop.cno = len
+ 					? len - multi_back(sp, p0, &p0[len])
+ 					: 0;
+ #endif /*MULTIBYTE*/
  	} else {
  		/*
  		 * Motion commands change the underlying movement (*snarl*).
***************
*** 846,853 ****
--- 940,961 ----
  		    motion.m_stop.cno = motion.m_start.cno = sp->cno;
  
  		/* Run the function. */
+ #ifndef MULTIBYTE
  		if ((motion.kp->func)(sp, &motion))
  			return (1);
+ #else
+ 	    {
+ 		int rval;
+ 
+ 		if (strchr(O_STR(sp, O_FEPKEY), motion.key))
+ 			v_fep_on(sp);
+ 		rval = (motion.kp->func)(sp, &motion);
+ 		if (strchr(O_STR(sp, O_FEPKEY), motion.key))
+ 			v_fep_off(sp);
+ 		if (rval)
+ 			return 1;
+ 	    }
+ #endif /*MULTIBYTE*/
  
  		/*
  		 * If the current line is missing, i.e. the file is empty,
***************
*** 1044,1050 ****
--- 1152,1162 ----
  	VI_PRIVATE *vip;
  	size_t beg, end, len;
  	int moved, state;
+ #ifndef MULTIBYTE
  	char *p;
+ #else
+ 	CHAR_T *p;
+ #endif
  
  	if (db_get(sp, sp->lno, DBG_FATAL, &p, &len))
  		return (1);
Index: vi/vi.h
Prereq: 	10.19 
*** nvi-1.79/vi/vi.h	Sat Sep 21 08:05:19 1996
--- nvi-1.79-m17n/vi/vi.h	Sun Feb  2 15:14:11 1997
***************
*** 18,24 ****
--- 18,29 ----
  typedef struct _vicmd {
  	CHAR_T	key;			/* Command key. */
  	CHAR_T	buffer;			/* Buffer. */
+ #ifndef MULTIBYTE
  	CHAR_T	character;		/* Character. */
+ #else
+ 	CHAR_T	characters[10];		/* Character. */
+ #define character	characters[0]
+ #endif
  	u_long	count;			/* Count. */
  	u_long	count2;			/* Second count (only used by z). */
  	EVENT	ev;			/* Associated event. */
***************
*** 167,172 ****
--- 172,181 ----
  int	cs_init __P((SCR *, VCS *));
  int	cs_next __P((SCR *, VCS *));
  int	cs_prev __P((SCR *, VCS *));
+ #ifdef MULTIBYTE
+ int	cs_multi_next __P((SCR *, VCS *));
+ int	cs_multi_prev __P((SCR *, VCS *));
+ #endif
  
  /*
   * We use a single "window" for each set of vi screens.  The model would be
***************
*** 216,222 ****
--- 225,235 ----
  typedef enum { CNOTSET, FSEARCH, fSEARCH, TSEARCH, tSEARCH } cdir_t;
  
  typedef enum { AB_NOTSET, AB_NOTWORD, AB_INWORD } abb_t;
+ #ifndef MULTIBYTE
  typedef enum { Q_NOTSET, Q_BNEXT, Q_BTHIS, Q_VNEXT, Q_VTHIS } quote_t;
+ #else
+ typedef enum { Q_NOTSET, Q_BNEXT, Q_BTHIS, Q_VNEXT, Q_VTHIS, Q_MULTIBYTE } quote_t;
+ #endif
  
  /* Vi private, per-screen memory. */
  typedef struct _vi_private {
***************
*** 235,241 ****
--- 248,259 ----
  	size_t	klen;		/* Keyword length. */
  	size_t	keywlen;	/* Keyword buffer length. */
  
+ #ifndef MULTIBYTE
  	CHAR_T	rlast;		/* Last 'r' replacement character. */
+ #else
+ 	CHAR_T	rlasts[10];	/* Last 'r' replacement character. */
+ #define rlast	rlasts[0]
+ #endif
  	e_key_t	rvalue;		/* Value of last replacement character. */
  
  	EVENT  *rep;		/* Input replay buffer. */
***************
*** 259,265 ****
--- 277,288 ----
  
  	u_long	u_ccnt;		/* Undo command count. */
  
+ #ifndef MULTIBYTE
  	CHAR_T	lastckey;	/* Last search character. */
+ #else
+ 	CHAR_T	lastckeys[10];	/* Last search character. */
+ #define lastckey lastckeys[0]
+ #endif /*MULTIBYTE*/
  	cdir_t	csearchdir;	/* Character search direction. */
  
  	SMAP   *h_smap;		/* First slot of the line map. */
